module     p0_dubar_emnebarg_d7h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W1jet/1.4/Virtual/p
   ! 0_dubar_emnebarg/helicity1/d7h1l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarg_config, only: ki
   use p0_dubar_emnebarg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarg_groups, only: &
!           & sign => diagram7_sign, shift => diagram7_shift
      use p0_dubar_emnebarg_globalsl1, only: epspow
      use p0_dubar_emnebarg_kinematics
      use p0_dubar_emnebarg_abbrevh1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d7
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k5
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d7 = 0.0_ki
      t1 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t7 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t8 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t9 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      d7 = (abb7n1+t1*abb7n13+t2*abb7n14+t3*abb7n3+t4*abb7n4+t5*abb7n5+t6*abb7n9&
      &+t1*t7*abb7n7+t1*t9*abb7n20+t2*t3*abb7n11+t2*t6*abb7n17+t2*t7*abb7n8+t2*t&
      &9*abb7n21+t3*t4*abb7n10+t3*t5*abb7n10+t3*t6*abb7n19+t3*t7*abb7n15+t3*t8*a&
      &bb7n18+t3*t9*abb7n22+t3*abb7n12*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*s&
      &pvak2k5(3)-Q(4)*spvak2k5(4))+t4*t6*abb7n18+t4*t7*abb7n6+t5*t6*abb7n16+t6*&
      &t7*abb7n2+t3*t7*t8*abb7n23)
      numerator = cmplx(real(d7, ki), aimag(d7), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarg_globalsl1, only: epspow
      use p0_dubar_emnebarg_kinematics
      use p0_dubar_emnebarg_abbrevh1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d7
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k5
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d7 = 0.0_ki
      t1 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t7 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t8 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t9 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      d7 = (abb7n1+t1*abb7n13+t2*abb7n14+t3*abb7n3+t4*abb7n4+t5*abb7n5+t6*abb7n9&
      &+t1*t7*abb7n7+t1*t9*abb7n20+t2*t3*abb7n11+t2*t6*abb7n17+t2*t7*abb7n8+t2*t&
      &9*abb7n21+t3*t4*abb7n10+t3*t5*abb7n10+t3*t6*abb7n19+t3*t7*abb7n15+t3*t8*a&
      &bb7n18+t3*t9*abb7n22+t3*abb7n12*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*s&
      &pvak2k5(3)-Q(4)*spvak2k5(4))+t4*t6*abb7n18+t4*t7*abb7n6+t5*t6*abb7n16+t6*&
      &t7*abb7n2+t3*t7*t8*abb7n23)

      numerator = cmplx(real(d7, ki), aimag(d7), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarg_d7h1l1
