module     p3_udbar_neepg_d3h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W1jet/1.4/Virtual/p
   ! 3_udbar_neepg/helicity0/d3h0l1.f90
   ! generator: haggies (1.1)
   use p3_udbar_neepg_config, only: ki
   use p3_udbar_neepg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p3_udbar_neepg_groups, only: &
!           & sign => diagram3_sign, shift => diagram3_shift
      use p3_udbar_neepg_globalsl1, only: epspow
      use p3_udbar_neepg_kinematics
      use p3_udbar_neepg_abbrevh0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d3

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d3 = 0.0_ki
      d3 = (abb3n1+abb3n2*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(&
      &4)*spvak2k5(4))+abb3n3*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3&
      &)-Q(4)*spvak2k1(4))+abb3n4*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5&
      &k1(3)-Q(4)*spvak5k1(4))+abb3n5*(Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*sp&
      &vak1k5(3)-Q(4)*spvak1k5(4))+abb3n6*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)&
      &*k1(4))+abb3n7*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4)))
      numerator = cmplx(real(d3, ki), aimag(d3), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p3_udbar_neepg_globalsl1, only: epspow
      use p3_udbar_neepg_kinematics
      use p3_udbar_neepg_abbrevh0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d3

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d3 = 0.0_ki
      d3 = (abb3n1+abb3n2*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(&
      &4)*spvak2k5(4))+abb3n3*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3&
      &)-Q(4)*spvak2k1(4))+abb3n4*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5&
      &k1(3)-Q(4)*spvak5k1(4))+abb3n5*(Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*sp&
      &vak1k5(3)-Q(4)*spvak1k5(4))+abb3n6*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)&
      &*k1(4))+abb3n7*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4)))

      numerator = cmplx(real(d3, ki), aimag(d3), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p3_udbar_neepg_d3h0l1
